/*
wijit wijitDlg.h : header file for the main dialog
Copyright (C) 1999-2000 Keith Minkler <tsbandit@jabber.org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You can reach The author at tsbandit@jabber.org (email or jid)
*/
//

#if !defined(AFX_WIJITDLG_H__A2DC9705_3C9C_11D4_8E41_00C04F6B1F5B__INCLUDED_)
#define AFX_WIJITDLG_H__A2DC9705_3C9C_11D4_8E41_00C04F6B1F5B__INCLUDED_

#include "wijit.h"	// Added by ClassView
#include "WSocket.h"	// Added by ClassView
#include "jabberoo.hh"
using namespace jabberoo;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CWijitDlg dialog

#include <list>
typedef list< string > STRING_LIST;
struct CL_STRUCT {
	CString Name;
	CString Type;
	DWORD Window;
	bool operator == ( CL_STRUCT v ) { return v.Name == Name; }
};
typedef list< CL_STRUCT > CHAT_LIST;
typedef struct {
	CString ServerName;
	CString UserName;
	CString Password;
	CString Resource;
} LOGON_INFO;
typedef struct _MRU_ {
	CString m1;
	CString m2;
	CString m3;
	CString m4;
	CString m5;
	CString m6;
	CString m7;
	CString m8;
	CString m9;
	CString m10;
} _MRU;



class CWijitDlg : public CDialog
{
// Construction
public:
	CHAT_LIST _ChatList;
	LOGON_INFO li;
	_MRU MRU;
	void WriteSettings(void);
	void ReadSettings(void);
	void Disconnect(void);
	void SetIconTray(const int Action,const int Image,const CString ToolTip) const;
	static void OnAuthError(int eCode,const char *msg);
	static void OnPresenceRequest(const Presence &p);
	static void OnPresence(const Presence &p);
	static void onIQ(const Tag &t);
	static void OnMessage(const Message &m);
	static void Disconnected(void);
	static void OnConnected(const Tag &t);
	WSocket _socket;

	CWijitDlg(CWnd* pParent = NULL);	// standard constructor
	Session _session;

// Dialog Data
	//{{AFX_DATA(CWijitDlg)
	enum { IDD = IDD_WIJIT_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWijitDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CWijitDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnConnect();
	afx_msg void OnClose();
	afx_msg void OnCancelMode();
	virtual void OnCancel();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnCaptureChanged(CWnd *pWnd);
	afx_msg void OnChat();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WIJITDLG_H__A2DC9705_3C9C_11D4_8E41_00C04F6B1F5B__INCLUDED_)
